﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter.Events;
using System.Windows.Media.Animation;
using System.Threading;
using System.Reflection;
using System.Diagnostics;

namespace XamDataGridAnimation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> coll { get; set; }

        public MainWindow()
        {

            InitializeComponent();
            coll = new ObservableCollection<Person>();

            for (int i = 0; i < 100000; i++)
            {
                coll.Add(new Person() { Id = i, LastName = "Smith", Age = 23 });
            }

            xamDataGrid1.RecordsInViewChanged += new EventHandler<RecordsInViewChangedEventArgs>(xamDataGrid1_RecordsInViewChanged);
        }

        Thread SplashThread;


        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Point currentWindowPosition = this.PointToScreen(new Point(this.ActualWidth / 2, this.ActualHeight / 2));

            SplashThread = new Thread(new ParameterizedThreadStart(ShowSplash));
            SplashThread.SetApartmentState(ApartmentState.STA);
            SplashThread.IsBackground = true;
            SplashThread.Start(currentWindowPosition);

            Debug.WriteLine("Opened");
            Debug.WriteLine(SplashThread.ManagedThreadId);
            
            xamDataGrid1.DataSource = null;
            xamDataGrid1.FieldLayouts.Clear();
            xamDataGrid1.DataSource = coll;
        }

        private static void ShowSplash(object P)
        {
            AnimationWindow SplashWindow = new AnimationWindow();
            SplashWindow.Top = ((Point)P).Y-SplashWindow.Height/2;
            SplashWindow.Left = ((Point)P).X - SplashWindow.Width/2;
            
            SplashWindow.Show();
            System.Windows.Threading.Dispatcher.Run();
            
        }

        void xamDataGrid1_RecordsInViewChanged(object sender, RecordsInViewChangedEventArgs e)
        {
            if (SplashThread.IsAlive)
            {
                Debug.WriteLine("Closed");
                Debug.WriteLine(SplashThread.ManagedThreadId);

                System.Windows.Threading.Dispatcher.FromThread(SplashThread).InvokeShutdown();
            }
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.DataSource = null;
            xamDataGrid1.FieldLayouts.Clear();
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;
        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }


        private double age;
        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }


        private String lastName;
        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }

    }
}
